package wicket.exemplo;

import org.apache.wicket.markup.html.WebMarkupContainer;
import org.apache.wicket.markup.html.WebPage;
import org.apache.wicket.markup.html.basic.Label;
import org.apache.wicket.markup.html.link.Link;

/**
 * Esta pgina tem um painel que  escondido ou mostrado quando um link  clicado. O texto do link 
 * alterado a cada clique.
 */
public class HomePage extends WebPage {
	
	private WebMarkupContainer painel;
	private Label labelDoLink;
    
    public HomePage() {
        
        // Construindo o painel e adicionando  pgina
    	painel = new WebMarkupContainer("painel");
    	add(painel);
    	
    	// Construindo o link com o comportamento de esconder e mostrar o painel
        Link linkDigarDesligar = new Link("linkEsconderMostrar") {
            @Override
            public void onClick() {
                painel.setVisible(!painel.isVisible());
                if (painel.isVisible()) {
                    /*
                     * Ignore por enquanto o significado de setModelObject. Saiba apenas que neste
                     * caso servir para mudar o valor do texto dentro do link.
                     */
                	labelDoLink.setModelObject("Desligar");
                } else {
                    labelDoLink.setModelObject("Ligar");
                }
            }
    	};
    	add(linkDigarDesligar);

        /*
         * Agora s falta o label do link. Note que ele  adicionado ao linkLigarDesligar, e no 
         * pgina.
         */
    	labelDoLink = new Label("label", "Desligar");
    	linkDigarDesligar.add(labelDoLink);
    }
    
}
