package wicket.exemplo;

import java.math.BigDecimal;
import java.math.RoundingMode;

import org.apache.wicket.markup.html.WebPage;
import org.apache.wicket.markup.html.basic.Label;
import org.apache.wicket.markup.html.link.Link;
import org.apache.wicket.model.PropertyModel;

/**
 * Um exemplo mais interessante com PropertyModel.
 */
public class HomePage extends WebPage {
    
    private Maratonista maratonista = new Maratonista();
    
    public HomePage() {
        Label cm = new Label("centimetros", new PropertyModel(this, "maratonista.centimetrosCorridos"));
        // Ou:
        // Label cm = new Label("centimetros", new PropertyModel(maratonista, "centimetrosCorridos"));
        add(cm);
        
        Label pes = new Label("pes", new PropertyModel(this, "pesCorridos"));
        add(pes);
        
        Link link = new Link("link") {

            @Override
            public void onClick() {
                maratonista.correrUmPasso();
            }
            
        };
        add(link);
    }
    
    public String getPesCorridos() {
        BigDecimal centimetros = new BigDecimal(maratonista.getCentimetrosCorridos());
        BigDecimal pes = centimetros.multiply(new BigDecimal("0.032808399"));
        
        return pes.setScale(2, RoundingMode.HALF_EVEN).toString();
    }
    
}
