package wicket.exemplo;

import java.util.Arrays;

import org.apache.wicket.markup.html.WebPage;
import org.apache.wicket.markup.html.form.ChoiceRenderer;
import org.apache.wicket.markup.html.form.DropDownChoice;
import org.apache.wicket.markup.html.form.Form;
import org.apache.wicket.markup.html.form.TextField;
import org.apache.wicket.markup.html.panel.FeedbackPanel;
import org.apache.wicket.model.PropertyModel;

/*
 * Este exemplo introduz:
 * - FeedbackPanel
 * - Herana de Form para responder ao Submit
 * - Exemplo de DropDownChoice com enum.
 * - Edio de um bean.
 */
public class HomePage extends WebPage {
    
    private Pessoa pessoa = new Pessoa();
    
    public HomePage() {
        
        FeedbackPanel feedbackPanel = new FeedbackPanel("feedback");
        add(feedbackPanel);
        
        Form form = new Form("form") {
            @Override
            protected void onSubmit() {
                HomePage.this.onFormSubmit();
            }
        };
        add(form);
        
        TextField nome = new TextField("nome", new PropertyModel(pessoa, "nome"));
        form.add(nome);
        
        ChoiceRenderer renderer = new ChoiceRenderer("nome");
        PropertyModel sexoModel = new PropertyModel(pessoa, "sexo");
        DropDownChoice sexo = new DropDownChoice("sexo", sexoModel, Arrays.asList(Sexo.values()), renderer);
        form.add(sexo);
        
        TextField idade = new TextField("idade", new PropertyModel(pessoa, "idade"));
        form.add(idade);
        
        TextField endereco = new TextField("endereco", new PropertyModel(pessoa, "endereco"));
        form.add(endereco);
    }
    
    protected void onFormSubmit() {
        System.out.println("Pessoa: " + pessoa);
    }
    
}
