package wicket.exemplo;

import java.util.Arrays;
import java.util.Locale;

import org.apache.wicket.Session;
import org.apache.wicket.markup.html.form.DropDownChoice;
import org.apache.wicket.model.IModel;

public class LocaleDropDown extends DropDownChoice {
    
    public static final Locale[] LOCALES = { new Locale("pt", "BR"), Locale.US,
            Locale.JAPAN };

    public LocaleDropDown(String id) {
        super(id, new SessionLocaleModel(), Arrays.asList(LOCALES));
    }

    protected static class SessionLocaleModel implements IModel {

        public Object getObject() {
            return Session.get().getLocale();
        }

        public void setObject(Object object) {
            Session.get().setLocale((Locale) object);
        }

        public void detach() {
        }

    }

}
