package wicket.exemplo;

import java.math.BigDecimal;

import org.apache.wicket.markup.html.WebPage;
import org.apache.wicket.markup.html.form.Form;
import org.apache.wicket.markup.html.form.TextField;
import org.apache.wicket.markup.html.panel.FeedbackPanel;
import org.apache.wicket.model.Model;
import org.apache.wicket.model.PropertyModel;
import org.apache.wicket.validation.validator.NumberValidator;
import org.apache.wicket.validation.validator.StringValidator;

public class HomePage extends WebPage {

    private String texto;
    
    private Integer idade;

    private BigDecimal bigDecimal = new BigDecimal("123.456");

	public HomePage() {

		FeedbackPanel feedbackPanel = new FeedbackPanel("feedback");
		add(feedbackPanel);

		final Form form = new Form("form");
		add(form);
		
		LocaleDropDown locales = new LocaleDropDown("locale");
        form.add(locales);

        // Texto requerido entre 3 e 200 caracteres
        TextField texto = new TextField("campoTexto", new PropertyModel(this,
                "texto"));
        texto.setLabel(new Model("Texto"));
        texto.setRequired(true);
        texto.add(StringValidator.lengthBetween(3, 200));
        form.add(texto);

        // Idade entre 0 e 150
        TextField idade = new TextField("campoIdade", new PropertyModel(this,
                "idade"));
        idade.setLabel(new Model("Idade"));
        idade.add(NumberValidator.range(0, 150));
        form.add(idade);

        // BigDecimal positivo menor ou igual a 200
		TextField bigDecimal = new TextField("campoBigDecimal",
                new PropertyModel(this, "bigDecimal"));
		bigDecimal.setLabel(new Model("Big Decimal"));
		bigDecimal.add(NumberValidator.POSITIVE);
        bigDecimal.add(NumberValidator.maximum(200));
        form.add(bigDecimal);
	}

    public String getTexto() {
        return texto;
    }

    public void setTexto(String texto) {
        this.texto = texto;
    }

    public BigDecimal getBigDecimal() {
        return bigDecimal;
    }

    public void setBigDecimal(BigDecimal bigDecimal) {
        this.bigDecimal = bigDecimal;
    }

    public Integer getIdade() {
        return idade;
    }

    public void setIdade(Integer idade) {
        this.idade = idade;
    }

}
