package wicket.exemplo;

import org.apache.wicket.markup.html.WebPage;
import org.apache.wicket.markup.html.form.Form;
import org.apache.wicket.markup.html.form.TextField;
import org.apache.wicket.markup.html.panel.FeedbackPanel;
import org.apache.wicket.model.Model;
import org.apache.wicket.model.PropertyModel;

public class HomePage extends WebPage {

    private String texto;
    
    private String data;
    
	public HomePage() {

		FeedbackPanel feedbackPanel = new FeedbackPanel("feedback");
		add(feedbackPanel);

		final Form form = new Form("form");
		add(form);
		
		LocaleDropDown locales = new LocaleDropDown("locale");
        form.add(locales);
        
        TextField dataString = new TextField("campoData", new PropertyModel(
                this, "data"));
        dataString.add(new PatternAmigavelValidator("\\d{2}/\\d{2}/\\d{4}",
                "dd/mm/aaaa"));
        dataString.setLabel(new Model("Data"));
        form.add(dataString);

        TextField texto = new TextField("campoTexto", new PropertyModel(this,
                "texto"));
        texto.setLabel(new Model("Texto"));
        texto.add(new InicialMaiusculaValidator());
        form.add(texto);
	}

	public String getTexto() {
        return texto;
    }

    public void setTexto(String texto) {
        this.texto = texto;
    }

    public String getData() {
        return data;
    }

    public void setData(String data) {
        this.data = data;
    }

}
