package wicket.exemplo;

import org.apache.commons.lang.StringUtils;
import org.apache.wicket.markup.html.WebPage;
import org.apache.wicket.markup.html.form.Form;
import org.apache.wicket.markup.html.form.TextField;
import org.apache.wicket.markup.html.panel.FeedbackPanel;
import org.apache.wicket.model.PropertyModel;

/**
 * Exemplo de uso de "flash messages": o programador incluir explicitamente
 * mensagens a serem apresentadas ao usurio.
 */
public class HomePage extends WebPage {

    private String texto;
    
	public HomePage() {

		FeedbackPanel feedbackPanel = new FeedbackPanel("feedback");
		add(feedbackPanel);

		final Form form = new Form("form") {
            @Override
            protected void onSubmit() {
                info("O submit funcionou!");
                if (StringUtils.isBlank(texto)) {
                    warn("Voc deixou o texto em branco.");
                } else {
                    info("Sucesso: voc digitou \"" + texto + "\"");
                }
            }
        };
		add(form);
		
        TextField texto = new TextField("campoTexto", new PropertyModel(this,
                "texto"));
        form.add(texto);
	}

	public String getTexto() {
        return texto;
    }

    public void setTexto(String texto) {
        this.texto = texto;
    }

}
