package wicket.exemplo;

import org.apache.wicket.markup.html.WebPage;
import org.apache.wicket.markup.html.basic.Label;
import org.apache.wicket.markup.html.list.ListItem;
import org.apache.wicket.markup.html.list.ListView;
import org.apache.wicket.model.Model;

import wicket.bugtracker.negocio.Projeto;
import wicket.bugtracker.negocio.ProjetoDao;

/**
 * Exemplo de ListView criando uma tabela. O ListView pode ser usado para
 * qualquer coisa que se repita, e no apenas tabelas.
 * 
 * Um outro exemplo seria uma lista (&lt;ul&gt; ou &lt;ol&gt;)
 */
public class HomePage extends WebPage {

    /*
     * Note que o ListView recebe uma lista ou um IModel. Se for IModel, deve
     * ser um que retorne sempre um List.
     */
	public HomePage() {
	    ProjetoDao dao = HelloApplication.get().getBugTracker().getProjetoDao();

	    ListView projetos = new ListView("projetos", dao.lista()) {

            @Override
            protected void populateItem(ListItem item) {
                Projeto projeto = (Projeto) item.getModelObject();
                item.add(new Label("id", new Model(projeto.getId())));
                item.add(new Label("nome", new Model(projeto.getNome())));
                Model bugsModel = new Model(projeto.getBugs().size());
                item.add(new Label("bugs", bugsModel));
            }

        };
        add(projetos);
	}

}
