package wicket.exemplo;

import org.apache.wicket.markup.html.WebPage;
import org.apache.wicket.markup.html.basic.Label;
import org.apache.wicket.markup.html.list.ListItem;
import org.apache.wicket.markup.html.list.ListView;
import org.apache.wicket.model.LoadableDetachableModel;
import org.apache.wicket.model.Model;

import wicket.bugtracker.negocio.Projeto;
import wicket.bugtracker.negocio.ProjetoDao;

public class HomePage extends WebPage {
    
    public HomePage() {
    	
        LoadableDetachableModel projetosModel = new LoadableDetachableModel() {

			@Override
			protected Object load() {
				System.out.println("projetosModel.load executado...");
				ProjetoDao dao = HelloApplication.get().getBugTracker()
						.getProjetoDao();
				return dao.lista();
			}

			/**
			 * No  necessrio sobrescrever este mtodo...  s para mostrar o
			 * ciclo de vida.
			 */
			@Override
			public void detach() {
				super.detach();
				System.out.println("projetosModel.detach executado...");
			}

		};

        ListView projetos = new ListView("projetos", projetosModel) {

            @Override
            protected void populateItem(ListItem item) {
                Projeto projeto = (Projeto) item.getModelObject();
                item.add(new Label("id", new Model(projeto.getId())));
                item.add(new Label("nome", new Model(projeto.getNome())));
                Model bugsModel = new Model(projeto.getBugs().size());
                item.add(new Label("bugs", bugsModel));
            }

        };
        add(projetos);
    }

}
