package wicket.exemplo;

import org.apache.wicket.markup.html.WebPage;
import org.apache.wicket.markup.html.basic.Label;
import org.apache.wicket.markup.html.list.ListItem;
import org.apache.wicket.markup.html.list.ListView;
import org.apache.wicket.model.IModel;
import org.apache.wicket.model.Model;

import wicket.bugtracker.negocio.Projeto;

public abstract class PaginaAbstrata extends WebPage {
    
    public PaginaAbstrata() {

        ListView projetos = new ListView("projetos", getModelParaALista()) {

            @Override
            protected void populateItem(ListItem item) {
                Projeto projeto = (Projeto) item.getModelObject();
                item.add(new Label("id", new Model(projeto.getId())));
                item.add(new Label("nome", new Model(projeto.getNome())));
                Model bugsModel = new Model(projeto.getBugs().size());
                item.add(new Label("bugs", bugsModel));
            }

        };
        add(projetos);
    }
    
    protected abstract IModel getModelParaALista();

}
