package wicket.exemplo;

import org.apache.wicket.model.IModel;
import org.apache.wicket.model.LoadableDetachableModel;

import wicket.bugtracker.negocio.ProjetoDao;

/**
 * O mesmo exemplo oe ListView mas com {@link LoadableDetachableModel}.
 */
public class PaginaComLoadableDetachableModel extends PaginaAbstrata {

    @Override
    protected IModel getModelParaALista() {
        LoadableDetachableModel projetosModel = new LoadableDetachableModel() {

            @Override
            protected Object load() {
                System.out.println("projetosModel.load executado...");
                ProjetoDao dao = HelloApplication.get().getBugTracker()
                        .getProjetoDao();
                return dao.lista();
            }
            
            /**
             * No  necessrio sobrescrever este mtodo...  s para mostrar o
             * ciclo de vida.
             */
            @Override
            public void detach() {
                super.detach();
                System.out.println("projetosModel.detach executado...");
            }
            
        };
        return projetosModel;
    }

}
