package wicket.exemplo;

import org.apache.wicket.Page;
import org.apache.wicket.Request;
import org.apache.wicket.RequestCycle;
import org.apache.wicket.Response;
import org.apache.wicket.protocol.http.WebApplication;
import org.apache.wicket.protocol.http.WebRequest;
import org.apache.wicket.protocol.http.WebRequestCycle;
import org.apache.wicket.protocol.http.WebResponse;

import wicket.bugtracker.negocio.BugTracker;

public class HelloApplication extends WebApplication {
    
    private BugTracker bugTracker;
    
    @Override
    public Class<?> getHomePage() {
        return HomePage.class;
    }
    
    @Override
    protected void init() {
        bugTracker = new BugTracker();
        mountBookmarkablePage("projeto", DetalhesProjeto.class);
    }
    
    public BugTracker getBugTracker() {
        return bugTracker;
    }
    
    public static HelloApplication get() {
        return (HelloApplication) WebApplication.get();
    }
    
    @Override
	public RequestCycle newRequestCycle(Request request, Response response) {
		return new WebRequestCycle(this, (WebRequest) request,
				(WebResponse) response) {
			@Override
			protected void onEndRequest() {
				Page page = getResponsePage();
				if (page != null) {
					System.out.println("Tamanho da pgina em bytes: "
							+ page.getSizeInBytes());
				}
			}
		};
	}
    
}
