package wicket.exemplo;

import org.apache.wicket.model.LoadableDetachableModel;

import wicket.bugtracker.negocio.BugTracker;
import wicket.bugtracker.negocio.Projeto;

/**
 * {@link LoadableDetachableModel} para um projeto.
 */
public class ProjetoDetachableModel extends
        LoadableDetachableModel {

    private int id;

    public ProjetoDetachableModel(int id) {
        this.id = id;
    }

    @Override
    protected Object load() {
        BugTracker bugTracker = HelloApplication.get().getBugTracker();
        return bugTracker.getProjetoDao().get(id);
    }
    
    /**
     * Atalho...
     */
    public Projeto getProjeto() {
        return (Projeto) getObject();
    }

    public int getId() {
        return id;
    }
    
}
