package wicket.bugtracker.negocio;

import java.util.HashSet;
import java.util.Set;

import org.joda.time.LocalDate;

public class Bug extends Entidade {
	
	private Projeto projeto;

	private String assunto;
	
	private BugStatus status;
	
	private String descricao;
	
	private LocalDate dataFechamento;
	
	private Set<Rotulo> rotulos = new HashSet<Rotulo>();
	
	public Bug() {
	}
	
	public Bug(Projeto projeto, String assunto, BugStatus status, String descricao) {
		this.projeto = projeto;
		this.assunto = assunto;
		this.status = status;
		this.descricao = descricao;
	}

	public Projeto getProjeto() {
		return projeto;
	}
	
	public void setProjeto(Projeto projeto) {
		this.projeto = projeto;
	}

	public String getAssunto() {
		return assunto;
	}

	public void setAssunto(String assunto) {
		this.assunto = assunto;
	}

	public BugStatus getStatus() {
		return status;
	}
	
	public void setStatus(BugStatus status) {
		this.status = status;
	}
	
	public String getDescricao() {
		return descricao;
	}

	public void setDescricao(String descricao) {
		this.descricao = descricao;
	}

	public Set<Rotulo> getRotulos() {
		return rotulos;
	}

	public void setRotulos(Set<Rotulo> rotulos) {
		this.rotulos = rotulos;
	}
	
	public void addRotulo(Rotulo rotulo) {
		rotulos.add(rotulo);
	}
	
	public void removeRotulo(Rotulo rotulo) {
		rotulos.remove(rotulo);
	}

	public LocalDate getDataFechamento() {
		return dataFechamento;
	}

	public void setDataFechamento(LocalDate dataFechamento) {
		this.dataFechamento = dataFechamento;
	}
	
}
