package wicket.bugtracker.negocio;

import static junit.framework.Assert.assertEquals;

import java.util.ArrayList;
import java.util.List;

import org.junit.Test;

public class AbstractDaoTest {
	
	private static class Pessoa extends Entidade {
		
		private String nome;
		
		public Pessoa(int id, String nome) {
			this.setId(id);
			this.nome = nome;
		}

		public String getNome() {
			return nome;
		}

		public void setNome(String nome) {
			this.nome = nome;
		}
	}
	
	private static class TesteDao extends AbstractDao<Pessoa> {

		@Override
		public Class<Pessoa> getClasseTratada() {
			return Pessoa.class;
		}
		
	}

	@Test
	public void testOrdenar() {
		
		List<Pessoa> lista = new ArrayList<Pessoa>();
		lista.add(new Pessoa(2, "Pessoa 2"));
		lista.add(new Pessoa(1, "Pessoa 1"));
		lista.add(new Pessoa(3, "Pessoa 3"));
		
		TesteDao dao = new TesteDao();

		List<Pessoa> nova = new ArrayList<Pessoa>(lista);

		dao.ordenar(nova, "id", true);
		assertEquals(1, nova.get(0).getId().intValue());
		assertEquals(2, nova.get(1).getId().intValue());
		assertEquals(3, nova.get(2).getId().intValue());
		
		dao.ordenar(nova, "id", false);
		assertEquals(1, nova.get(2).getId().intValue());
		assertEquals(2, nova.get(1).getId().intValue());
		assertEquals(3, nova.get(0).getId().intValue());
		
		dao.ordenar(nova, "nome", true);
		assertEquals("Pessoa 1", nova.get(0).getNome());
		assertEquals("Pessoa 2", nova.get(1).getNome());
		assertEquals("Pessoa 3", nova.get(2).getNome());
		
		dao.ordenar(nova, "nome", false);
		assertEquals("Pessoa 1", nova.get(2).getNome());
		assertEquals("Pessoa 2", nova.get(1).getNome());
		assertEquals("Pessoa 3", nova.get(0).getNome());
	}

}
