package wicket.bugtracker.negocio;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertSame;

import java.util.List;

import org.junit.Test;

public class ProjetoDaoTest {

    @Test
    public void testFindPorNomeString() {
        ProjetoDao dao = new ProjetoDao();

        Projeto p1 = new Projeto();
        p1.setNome("Projeto 1");
        dao.store(p1);

        Projeto p2 = new Projeto();
        p2.setNome("Projeto 2");
        dao.store(p2);

        Projeto p3 = new Projeto();
        p3.setNome("Projeto 3");
        dao.store(p3);

        Projeto p4 = new Projeto();
        p4.setNome("Nome diferente");
        dao.store(p4);

        assertEquals(4, dao.findPorNome(null).size());
        assertEquals(4, dao.findPorNome("").size());
        assertEquals(3, dao.findPorNome("projeto").size());
        assertEquals(3, dao.findPorNome("Projeto").size());
        assertEquals(4, dao.findPorNome("O").size());
        assertEquals(4, dao.findPorNome("o").size());
        assertEquals(1, dao.findPorNome("o 1").size());
    }

    @Test
    public void testFindPorNomeStringIntInt() {

        ProjetoDao dao = new ProjetoDao();

        Projeto p1 = new Projeto();
        p1.setNome("Projeto 1");
        dao.store(p1);

        Projeto p2 = new Projeto();
        p2.setNome("Projeto 2");
        dao.store(p2);

        Projeto p3 = new Projeto();
        p3.setNome("Projeto 3");
        dao.store(p3);

        Projeto p4 = new Projeto();
        p4.setNome("Nome diferente");
        dao.store(p4);

        assertList(dao.findPorNome(null, 0, 10), p1, p2, p3, p4);
        assertList(dao.findPorNome(null, 1, 10), p2, p3, p4);
        assertList(dao.findPorNome(null, 0, 2), p1, p2);
        assertList(dao.findPorNome(null, 1, 2), p2, p3);
        assertList(dao.findPorNome("", 1, 2), p2, p3);
        assertList(dao.findPorNome("projeto", 1, 2), p2, p3);
        assertList(dao.findPorNome("o 1", 0, 2), p1);
        assertList(dao.findPorNome("o 1", 1, 2));
    }

    private void assertList(List<Projeto> actual, Projeto... expected) {
        assertEquals(expected.length, actual.size());
        for (int i = 0; i < expected.length; i++) {
            assertSame("Projeto " + i + " no  o mesmo", expected[i], actual.get(i));
        }
    }

}
